              #include <p12f675.inc>
              LIST        p=12F675          ;   .
              __CONFIG    03F81H            ;   4

Sec           equ         20h
Sec0          equ         21h
Sec1          equ         22h
var           equ         23h
kod           equ         24h
shetbit       equ         25h

#define       knp1        GPIO,1            ;   -
#define       dat         GPIO,2

              org         0                 ;      0 PC.
              goto        Start             ;    Start.
      
Start         movlw       b'00000111'       ; 
              movwf       CMCON             ;
              movlw       b'00000000'       ;      GPIO
              movwf       GPIO              ;
              bsf         STATUS,RP0        ; 1- 
              movlw       b'00111011'       ;  \  GPIO
              movwf       TRISIO            ;GP2- ,  
              bcf         ANSEL,ANS1        ;GP1- 
              ;bsf         IOCB,IOCB1        ;    
                                            ;  GP1
              bcf         STATUS,RP0        ; 0- 
                 
;son           movf        GPIO,W            ;  GPIO   
             ; bcf         INTCON,GPIF       ;       GP0-GP5
             ; bsf         INTCON,GPIE       ;      GP0-GP5
             ; SLEEP                         ;   
             ; bcf         INTCON,GPIE       ;       GP0-GP5
         
metka3        btfsc       knp1              ;   knp1 
              goto        metka3            ; ( ):   metka4
              call        nagat             ; ( ):  nagat
              call        paus200           ;   200             
              goto        metka3            ;   metka3:   knp1
;metka4        call        pausknp           ;   10
 ;             goto        son               ;   son
                                      
nagat         call        preamb            ;   
              movlw       .196              ;  196  
              call        send              ;
              movlw       .46               ;  46  
              call        send              ; 
              return                        ;  

send          movwf       kod
              movlw       .8                ;  8   shetbit,   
              movwf       shetbit           ;  
opros         btfsc       kod,7             ; 7-   kod
              goto        prdedin           ;  1:   prdedin 

prdnol        bcf         dat               ;  0:  
              call        paus500
              bsf         dat
              call        paus250
              goto        metka1
                          
prdedin       bcf         dat               ;  
              call        paus250
              bsf         dat
              call        paus500

metka1        rlf         kod,F             ;   kod   
                                            ; 
              decfsz      shetbit,F         ;   
              goto        opros             ;   :   opros
              bcf         dat               ;  :   dat(   
                                            ;    )
              return                        ;  

preamb        movlw       .8                ;    -
              movwf       var               ;-      
bb1           bcf         dat               ;(010101...01) 16  - 2 
              call        paus500
              bsf         dat
              call        paus500
              decfsz      var,F
              goto        bb1
              return

pausknp       movlw       .13               ;  10
              movwf       Sec
a2            movlw       .255
              movwf       Sec0
a1            decfsz      Sec0,F
              goto        a1
              decfsz      Sec,F
              goto        a2
              return

paus250       movlw       .83               ;  250
              movwf       Sec0
aa1           decfsz      Sec0,F
              goto        aa1
              return 

paus500       movlw       .166              ;  500
              movwf       Sec0
aa2           decfsz      Sec0,F
              goto        aa2
              return 

paus200       movlw       .4                ;  200
              movwf       Sec
as2           movlw       .66
              movwf       Sec0
as3           movlw       .255
              movwf       Sec1
as1           decfsz      Sec1,F
              goto        as1
              decfsz      Sec0,F
              goto        as3
              decfsz      Sec,F
              goto        as2
              return

              End                            ;  